library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use std.textio.all;
use ieee.std_logic_textio.all;

entity inst_memory is
port
(
addr: IN std_logic_VECTOR(8 downto 0);
inst: OUT std_logic_VECTOR(23 downto 0)
);
end inst_memory;

architecture behavioral of inst_memory is
type rom_type is array (511 downto 0) of std_logic_vector (23 downto 0);

impure function InitRomFromFile (RomFileName : in string) return rom_type is
    FILE romfile : text is in RomFileName;
    variable RomFileLine : line;
    variable rom : rom_type;
begin
    for i in rom_type'range loop
        readline(romfile, RomFileLine);
        hread(RomFileLine, rom(i));
    end loop;
    return rom;
end function;

signal rom : rom_type := InitRomFromFile("loading_vector.txt");

begin
 
inst <= rom(conv_integer(addr));

end behavioral;