﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO.Ports;
using System.Threading;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using System.Timers;
using System.Globalization;
using System.Collections;
using System.IO;
using System.Runtime.InteropServices;

namespace HEVC_CABAC_Verification_Tool
{

    public partial class Form1 : Form
    {
        static StreamReader input;

        static bool binary = true;

        static StreamReader Decoderinput;
        static StreamWriter DecoderOutput;

        static StreamReader Original;
        static string Original_string,Encoded_here;

        static uint initType, sliceQPY, ContextIndex;

        static uint qCodIRangeidx, CodIrangeLPS, codIRange, codIOffset, offset, codILow;
        static uint bitsOutstanding;
        static bool firstBitFlag;

        RichTextBox PutBitTarget;
        uint PutBitIndex;

        RichTextBox binValTarget;
        uint binValIndex;

        static uint ctxIdxTable_depth = 120;

        static uint[,] rangeTabLPS = new uint[64,4];
        static uint[] transIdxMPS = new uint[64];
        static uint[] transIdxLPS = new uint[64];
        static uint[] pStateIdxTable = new uint[ctxIdxTable_depth * 3 * 52];
        static uint[] MPSIdxTable = new uint[ctxIdxTable_depth * 3 * 52];

        CABAC_encoder Enc = new CABAC_encoder();
        CABAC_decoder Dec = new CABAC_decoder();

        // Used for signaling Binarization Bypass flag.
        static uint[] BypassFlag;// = new uint[65535];
        char[] read_bits_target;
        uint read_bits_index;

        static List<bin> encodedhere;



        public Form1()
        {
            InitializeComponent();

            Offset_change(this, new EventArgs());
            Load_Original_bt_Click(this, new EventArgs());
        }

        private void button1_Click(object sender, EventArgs e)
        {
            StreamWriter Output;
            Output = initializeWriteFile("initOutput.txt");

            input = initializeReadFile("initinput.txt");


            Int32 initValue, slopeIdx, intersecIdx, m, n, preCtxState, valMPS, pStateIdx;

            try
            {
                for (int SliceQPY = 0; SliceQPY < 52; SliceQPY++)
                {

                    while (!input.EndOfStream)
                    {
                        initValue = int.Parse(input.ReadLine());
                        slopeIdx = initValue >> 4;
                        intersecIdx = initValue & 15;
                        m = (slopeIdx * 5) - 45;
                        n = (intersecIdx << 3) - 16;
                        preCtxState = Clip3(1, 126, ((m * Clip3(0, 51, SliceQPY)) >> 4) + n);
                        valMPS = (preCtxState <= 63) ? 0 : 1;
                        pStateIdx = (valMPS > 0) ? (preCtxState - 64) : (63 - preCtxState);
                        if (binary)
                        {
                            //Output.WriteLine(String.Format("{0:X}", valMPS) + Convert.ToString(pStateIdx, 2).PadLeft(6, '0'));
                            //Output.WriteLine(String.Format("{0:X}", valMPS)); //MPS
                            //Output.WriteLine(Convert.ToString(pStateIdx, 2).PadLeft(6, '0'));
                            //Output.WriteLine(valMPS.ToString()); //MPS
                            Output.WriteLine(pStateIdx.ToString());
                        }
                        else
                        {
                            //Output.WriteLine("0" + String.Format("{0:X}", valMPS) + String.Format("{0:X2}", pStateIdx));
                            //Output.WriteLine(String.Format("{0:X}", valMPS)); // MPS
                            //Output.WriteLine(String.Format("{0:X2}", pStateIdx));
                            //Output.WriteLine(String.Format("{0:X}", valMPS)); // MPS
                            //Output.WriteLine(String.Format("{0:X2}", pStateIdx));
                        }
                    }
                    input.DiscardBufferedData();
                    input.BaseStream.Seek(0, System.IO.SeekOrigin.Begin);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
            Output.Close();
            input.Close();
        }

        private StreamWriter initializeWriteFile(string filename)
        {
            try
            {
                FileStream fs;
                StreamWriter file;
                string startUpPath;
                string currentLogFileName;
                string logfolder;
                //TODO Check if file and folders excists
                currentLogFileName = string.Format(filename);// There are following custom format specifiers y (year), M (month), d (day), h (hour 12), H (hour 24), m (minute), s (second), f (second fraction), F (second fraction, trailing zeroes are trimmed), t (P.M or A.M) and z (time zone).
                startUpPath = Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location);
                logfolder = Path.Combine(startUpPath, currentLogFileName);
                File.Delete(logfolder);
                fs = File.Create(logfolder);
                file = new StreamWriter(fs);
                return file;
            }
            catch (IOException)
            {
                MessageBox.Show("Unable to access: " + filename);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
            return null;
        }

        private StreamReader initializeReadFile(string filename)
        {
            try
            {
                FileStream fs;
                StreamReader file;
                string startUpPath;
                string currentLogFileName;
                string logfolder;
                //TODO Check if file and folders excists
                currentLogFileName = string.Format(filename);// There are following custom format specifiers y (year), M (month), d (day), h (hour 12), H (hour 24), m (minute), s (second), f (second fraction), F (second fraction, trailing zeroes are trimmed), t (P.M or A.M) and z (time zone).
                startUpPath = Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location);
                logfolder = Path.Combine(startUpPath, currentLogFileName);
                fs = File.OpenRead(logfolder);
                file = new StreamReader(fs);
                return file;
            }
            catch (IOException)
            {
                MessageBox.Show("Unable to access: " + filename);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
            return null;
        }

        int Clip3(int x, int y, int z)
        {
            if (z < x) return x;
            else if (z > y) return y;
            else return z;
        }

        private void BinaryRB_CheckedChanged(object sender, EventArgs e)
        {
            binary = BinaryRB.Checked;
        }

        private void Load_Original_bt_Click(object sender, EventArgs e)
        {
            Original = initializeReadFile("TestFile.txt");
            char[] tempA = new char[65535];
            int charpos = 0;
            while (!Original.EndOfStream)
            {
                for (int i = 0; i < int.Parse(Original_DataLength_tb.Text); i++)
                {
                    int temp = Original.Read();
                    if (temp == 48 || temp == 49)
                    {
                        tempA[i + charpos] = (char)temp;
                    }
                    //else if (temp == 13 || temp == 10)
                    //{
                    //    // CR+LF
                    //}
                    else
                    {
                        //tempA[i + charpos] = 'X';
                    }
                }
                charpos += int.Parse(Original_DataLength_tb.Text);
                Original.ReadLine();
            }
            tempA[charpos++] = '\0';
            Original_string = ReplaceNewlines(new string(tempA), "").Substring(0, charpos);
            Original.Close();
            FormatRTB(Original_tb, int.Parse(Original_DataLength_tb.Text), Original_string);
        }

        private void HexRB_CheckedChanged(object sender, EventArgs e)
        {
            binary = !HexRB.Checked;
        }



#region Encoder

       

        private void Encode_btn_Click(object sender, EventArgs e)
        {
            ReloadTables();
            Enc.ResetCodeVals();
            Enc.offset = offset;
            Enc.firstBitFlag = true;

            bool firstskip;
            bool typeset;
            List<Syntax_element> S_E_list = new List<Syntax_element>();

            Original = initializeReadFile("EncoderInput.txt");

            while (!Original.EndOfStream)
            {
                firstskip = true;
                typeset = false;
                Syntax_element S_E = new Syntax_element();

                foreach (char c in Original.ReadLine())
                {
                    if (firstskip)
                    {
                        firstskip = false;
                        S_E.bypass = (c == '1') ? true : false;
                    }   
                    else
                    {
                        if (c == ',')
                        {

                        }
                        else
                        {
                            S_E.Bins.Add(c);
                            S_E.nr++;
                        }
                    }
                }
                //MessageBox.Show(new string(S_E.bins));
                S_E_list.Add(S_E);
            }
            //int lol = 1;

            //Original_tb.Clear();
            //foreach (Syntax_element S_E in S_E_list)
            //{
            //    foreach (char b in S_E.Bins)
            //    {
            //        Original_tb.AppendText(b.ToString());
            //    }
            //}

            Encoded_Here_tb.Clear();


            StreamWriter write = initializeWriteFile("DecoderInputHere.txt");

            foreach (bin b in Enc.Encode(S_E_list))
            {
                Encoded_Here_tb.AppendText(b.val.ToString());
            }
            

            write.Close();  

            Original.Close();
            DisplayCtxStatus();
        }

#endregion

        private void ReloadTables()
        {

            StreamReader rangeTabLPSSR = initializeReadFile("rangeTabLPS.txt");
            StreamReader transIdxMPSSR = initializeReadFile("transIdxMPS.txt");
            StreamReader transIdxLPSSR = initializeReadFile("transIdxLPS.txt");

            for (int i = 0; i < 64; i++)
            {
                rangeTabLPS[i, 0] = uint.Parse(rangeTabLPSSR.ReadLine(), NumberStyles.HexNumber);
            }
            for (int i = 0; i < 64; i++)
            {
                rangeTabLPS[i, 1] = uint.Parse(rangeTabLPSSR.ReadLine(), NumberStyles.HexNumber);
            }
            for (int i = 0; i < 64; i++)
            {
                rangeTabLPS[i, 2] = uint.Parse(rangeTabLPSSR.ReadLine(), NumberStyles.HexNumber);
            }
            for (int i = 0; i < 64; i++)
            {
                rangeTabLPS[i, 3] = uint.Parse(rangeTabLPSSR.ReadLine(), NumberStyles.HexNumber);
            }

            for (int i = 0; i < 64; i++)
            {
                transIdxMPS[i] = uint.Parse(transIdxMPSSR.ReadLine(), NumberStyles.HexNumber);
                transIdxLPS[i] = uint.Parse(transIdxLPSSR.ReadLine(), NumberStyles.HexNumber);
            }

            StreamReader pStateIdxTableF = initializeReadFile("pStateIdxTable.txt");
            StreamReader MPSIdxTableF = initializeReadFile("MPSIdxTable.txt");

            //MessageBox.Show(MPSIdxTableF.ReadLine());
            for (int i = 0; i < ctxIdxTable_depth * 3 * 52; i++)
            {
                pStateIdxTable[i] = Convert.ToUInt32(pStateIdxTableF.ReadLine());//, 2);
                MPSIdxTable[i] = Convert.ToUInt32(MPSIdxTableF.ReadLine());//, 2);
            }

            DisplayCtxStatus();
            //Convert.ToString(pStateIdx, 2).PadLeft(6, '0')
            Console_Printout_tb.Clear();
            for (uint i = 0; i < 64; i++)
            {
                Console_Printout_tb.AppendText(i.ToString().PadLeft(2, '0')
                                + "  rangeTabLPS: [" + i.ToString().PadLeft(2, '0') + ",0]:  " + rangeTabLPS[i, 0].ToString().PadLeft(3, '0')
                                + "  [" + i.ToString().PadLeft(2, '0') + ",1]:  " + rangeTabLPS[i, 1].ToString().ToString().PadLeft(3, '0')
                                + "  [" + i.ToString().PadLeft(2, '0') + ",2]:  " + rangeTabLPS[i, 2].ToString().ToString().PadLeft(3, '0')
                                + "  [" + i.ToString().PadLeft(2, '0') + ",3]:  " + rangeTabLPS[i, 3].ToString().ToString().PadLeft(3, '0')
                                + "  transIdxMPS: " + transIdxMPS[i].ToString().ToString().PadLeft(3, '0')
                                + "  transIdxLPS: " + transIdxLPS[i].ToString().ToString().PadLeft(3, '0') + "\n");
            }

            Dec.rangeTabLPS = rangeTabLPS;
            Dec.transIdxMPS = transIdxMPS;
            Dec.transIdxLPS = transIdxLPS;
            Dec.pStateIdxTable = pStateIdxTable;
            Dec.MPSIdxTable = MPSIdxTable;


            Enc.rangeTabLPS = rangeTabLPS;
            Enc.transIdxMPS = transIdxMPS;
            Enc.transIdxLPS = transIdxLPS;
            Enc.pStateIdxTable = pStateIdxTable;
            Enc.MPSIdxTable = MPSIdxTable;

            rangeTabLPSSR.Close();
            transIdxMPSSR.Close();
            transIdxLPSSR.Close();
            pStateIdxTableF.Close();
            MPSIdxTableF.Close();
        }

        private void DisplayCtxStatus()
        {
            Console_tb.Clear();
            uint offsetMinusCtxIdx = offset - ContextIndex;
            //for (uint i = offsetMinusCtxIdx; i < offsetMinusCtxIdx + ctxIdxTable_depth; i++)
            //{
            //    Console_tb.AppendText(i.ToString() + " : " + Convert.ToString(MPSIdxTable[i], 2)
            //                    + " : " + Convert.ToString(pStateIdxTable[i], 2).PadLeft(6, '0')
            //                    + " : " + Convert.ToString(rangeTabLPS[i % 64, 0], 2).PadLeft(6, '0')
            //                    + " : " + Convert.ToString(rangeTabLPS[i % 64, 1], 2).PadLeft(6, '0')
            //                    + " : " + Convert.ToString(rangeTabLPS[i % 64, 2], 2).PadLeft(6, '0')
            //                    + " : " + Convert.ToString(rangeTabLPS[i % 64, 3], 2).PadLeft(6, '0')
            //                    + " : " + Convert.ToString(transIdxMPS[i % 64], 2).PadLeft(6, '0')
            //                    + " : " + Convert.ToString(transIdxLPS[i % 64], 2).PadLeft(6, '0') + "\n");
            //}
            //MessageBox.Show("offsetMinusCtxIdx: " + offsetMinusCtxIdx.ToString() +
            //                        " offset: " + offset.ToString());

            for (uint i = offsetMinusCtxIdx; i < offsetMinusCtxIdx + ctxIdxTable_depth; i++)
            {
                Console_tb.AppendText(i.ToString().PadLeft(5,'0') + " : " + Convert.ToString(MPSIdxTable[i]/*, 2*/)
                                + " : " + Convert.ToString(pStateIdxTable[i]/*, 2*/).PadLeft(3, '0'));

                //if(offset == i)
                //{
                //    Console_tb.AppendText("<<<");
                //}

                Console_tb.AppendText("\n");
            }
            //Console_tb.Select((int)(offset % ctxIdxTable_depth),20);
            Console_tb.SelectionStart = Console_tb.Find(Console_tb.Lines[(int)(offset % ctxIdxTable_depth)]);
            Console_tb.ScrollToCaret();
            HighlightLine(Console_tb, (int)(offset % ctxIdxTable_depth), Color.LightGreen);
        }

        private void HighlightLine(RichTextBox richTextBox, int index, Color color)
        {
            richTextBox.SelectAll();
            richTextBox.SelectionBackColor = richTextBox.BackColor;
            var lines = richTextBox.Lines;
            if (index < 0 || index >= lines.Length)
                return;
            var start = richTextBox.GetFirstCharIndexFromLine(index);  // Get the 1st char index of the appended text
            var length = lines[index].Length;
            richTextBox.Select(start, length);                 // Select from there to the end
            richTextBox.SelectionBackColor = color;
        }

        private void firstBitFlag_cb_CheckedChanged(object sender, EventArgs e)
        {
            firstBitFlag = firstBitFlag_cb.Checked;
        }

        private uint[] BinaryStringtoUintA(string inputS, out uint length)
        {
            uint[] tempUintA = new uint[inputS.Length];
            try
            {
                char[] tembA = inputS.ToCharArray();

                for (uint j = 0; j < inputS.Length; j++)
                {
                    int temp = tembA[j];
                    if (temp == '0')
                    {
                        tempUintA[j] = 0;
                    }
                    else if (temp == '1')
                    {
                        tempUintA[j] = 1;
                    }
                    else if (temp == 13 || temp == 10)
                    {
                        // CR+LF
                    }
                    else
                    {

                    }
                }
                length = (uint)inputS.Length;
                return tempUintA;
            } 
            catch (Exception ex)
            {
                MessageBox.Show("Exception during call to BinaryStringtoUintA():\n\n" + ex.ToString());
            }
            length = 0;
            return tempUintA;
        }

        private void ResetTbl_tb_Click(object sender, EventArgs e)
        {
            ReloadTables();
        }

        private void ResetCodeVals()
        {
            //The status of the arithmetic decoding engine is represented by the variables codIRange and codIOffset.
            //In the initialization procedure of the arithmetic decoding process, 
            //codIRange is set equal to 510 and codIOffset is set equal to the value returned from read_bits(9) 
            //interpreted as a 9 bit binary representation of an unsigned integer with most significant bit written first.
            codIRange = 510;
            codILow = 0;
            qCodIRangeidx = 0;
            CodIrangeLPS = 0;
            codIOffset = 0;
            codILow = 0;
        }

        #region Decoder

       

        private void Decode_btn_Click(object sender, EventArgs e)
        {
            ReloadTables();
            bool firstskip;

            if (Decode_From_File_cb.Checked)
            {
                Decoderinput = initializeReadFile("DecoderInput.txt");
            }
            else
            {
                Decoderinput = initializeReadFile("DecoderInputHere.txt");
            }
            Dec.binValTarget = DecoderOutput_tb;
            Dec.offset = offset;
            
            DecoderOutput_tb.Clear();
            DecoderOutput_tb.AppendText(Dec.Decode(encodedhere));
            Decoderinput.Close();
        }
        //{
        //    firstBitFlag_cb.Checked = false;
        //    char[] codIOffsetInit = "XXXXXXXXX".ToCharArray();
        //    //List<syntax_element> bins = new List<syntax_element>();
        //    uint codIOffsetInitindex = 0;
        //    bool firstskip;
        //    bool Bypass = false;
        //    //char[] codIOffsetInit = "XXXXXXXXXX".ToCharArray();
        //    uint[] bits = new uint[65536];
        //    uint bits_index = 9; //FIRST 9 initialized

        //    UInt32 looplength, bits_read = 0;

        //    if (Reload_Tables_Before_Decoding_cb.Checked)
        //    {
        //        ReloadTables();
        //    }


        //    ResetCodeVals();

        //    //if (Decode_From_File_cb.Checked) //On pause until Encode_from_here is working
        //    //{
        //    //    try
        //    //    {
        //    //        Decoderinput = initializeReadFile("DecoderInput.txt");

        //    //        while (!Decoderinput.EndOfStream)
        //    //        {
        //    //            firstskip = true;
        //    //            //syntax_element S_E = new syntax_element();

        //    //            foreach (char c in Decoderinput.ReadLine())
        //    //            {
        //    //                if (firstskip)
        //    //                {
        //    //                    firstskip = false;
        //    //                    S_E.Bypass = (c == '1') ? true : false;
        //    //                }
        //    //                else
        //    //                {
        //    //                    if (c == ',')
        //    //                    {

        //    //                    }
        //    //                    else
        //    //                    {
        //    //                        S_E.bins[S_E.length++] = c;
        //    //                    }
        //    //                }
        //    //            }
        //    //            //MessageBox.Show(new string(S_E.bins));
        //    //            //bins.Add(S_E);
        //            }

        //            ////foreach(syntax_element S_E in bins)
        //            //{
        //            //    MessageBox.Show(new string(S_E.bins));
        //            //}



        //                //string lineread;
        //                //string remainder;
        //                //int remaindedpos;

        //                //while(codIOffsetInitindex < 9 && !Decoderinput.EndOfStream)
        //                //{
        //                //    lineread = Decoderinput.ReadLine();
        //                //    firstskip = true;
        //                //    remaindedpos = 1;
        //                //    foreach (char c in lineread)
        //                //    {
        //                //        if (firstskip)
        //                //        {
        //                //            firstskip = false;
        //                //            Bypass = (c == '1') ? true : false;
        //                //        }
        //                //        else
        //                //        {
        //                //            if (c == ',')// || c != '0' || c != '1')
        //                //            {

        //                //            }
        //                //            else if (codIOffsetInitindex < 9)
        //                //            {
        //                //                codIOffsetInit[codIOffsetInitindex++] = c;
        //                //                remaindedpos++;
        //                //            }
        //                //            else if (codIOffsetInitindex == 9)
        //                //            {
        //                //                remainder = lineread.Substring(remaindedpos, lineread.Length-3);
        //                //            }
        //                //        }
        //                //    }
        //                //}

        //                //if (codIOffsetInitindex < 9)
        //                //{
        //                //    MessageBox.Show("DecoderInput.txt file does not contain enough data.");
        //                //    return;
        //                //}

        //                //codIOffset = Convert.ToUInt32(new string(codIOffsetInit), 2);

        //                //Decoderinput.DiscardBufferedData();
        //                //Decoderinput.BaseStream.Seek(0, System.IO.SeekOrigin.Begin);



        //                //while (!Decoderinput.EndOfStream)
        //                //{
        //                //    lineread = Decoderinput.ReadLine();
        //                //    firstskip = true;
        //                //    foreach (char c in lineread)
        //                //    {
        //                //        if (firstskip)
        //                //        {
        //                //            firstskip = false;
        //                //            Bypass = (c == '1') ? true : false;
        //                //        }
        //                //        else if (c == ',')// || c != '0' || c != '1')
        //                //        {

        //                //        }
        //                //        else if (Bypass)
        //                //        {
        //                //            DecodeBypass(ref codIRange, ref codIOffset, ref bits_index, ref bits);
        //                //        }
        //                //        else
        //                //        {
        //                //            DecodeDecicison(ref codIRange, ref codIOffset, ref bits_index, ref bits);
        //                //        }
        //                //    }
        //                //}



        //                Decoderinput.Close();
        //        }
        //        catch (Exception ex)
        //        {
        //            MessageBox.Show("Exception during call to Decode_btn_Click():\n\n" + ex.ToString());
        //        }
        //    }
        //    else if (Decode_From_Here_cb.Checked)
        //    {
        //        try
        //        {
        //            bits = BinaryStringtoUintA(Encoded_here, out bits_read);
        //            //codIOffsetInit = Encoded_here.Substring(0, 9);
        //        }
        //        catch (Exception ex)
        //        {
        //            MessageBox.Show("Exception during call to Decode_btn_Click():\n\n" + ex.ToString());
        //        }
        //    }

        //    ////codIRange is set equal to 510 and codIOffset is set equal to the value returned from read_bits(9) 
        //    ////codIOffset = Convert.ToUInt32(codIOffsetInit, 2); // read 9 first binary vals

        //    //Initiate_binVal(DecoderOutput_tb);

        //    //    try
        //    //    {
        //    //        if (Bypass_cb.Checked)
        //    //        {
        //    //            while (bits_index < bits_read)
        //    //            {
        //    //                DecodeBypass(ref codIRange, ref codIOffset, ref bits_index, ref bits);
        //    //            }
        //    //        }
        //    //        else
        //    //        {
        //    //            while (bits_index < bits_read)
        //    //            {
        //    //                DecodeDecicison(ref codIRange, ref codIOffset, ref bits_index, ref bits);
        //    //            }
        //    //        }
        //    //        DisplayCtxStatus();
        //    //    }
        //    //    catch (Exception ex)
        //    //    {
        //    //        MessageBox.Show("Exception during call to Decode_btn_Click():\n\n" + ex.ToString());
        //    //    }
        //}

        #endregion

        

        private void Binarize_bt_Click(object sender, EventArgs e)
        {
            try
            {
                Int16[,] TB = {  { Int16.Parse(TB00_tb.Text), Int16.Parse(TB01_tb.Text), Int16.Parse(TB02_tb.Text), Int16.Parse(TB03_tb.Text) },
                                 { Int16.Parse(TB10_tb.Text), Int16.Parse(TB11_tb.Text), Int16.Parse(TB12_tb.Text), Int16.Parse(TB13_tb.Text) },
                                 { Int16.Parse(TB20_tb.Text), Int16.Parse(TB21_tb.Text), Int16.Parse(TB22_tb.Text), Int16.Parse(TB23_tb.Text) },
                                 { Int16.Parse(TB30_tb.Text), Int16.Parse(TB31_tb.Text), Int16.Parse(TB32_tb.Text), Int16.Parse(TB33_tb.Text) }  };

                Int16[] TBDiagonal = {  Int16.Parse(TB33_tb.Text), Int16.Parse(TB32_tb.Text), Int16.Parse(TB23_tb.Text), Int16.Parse(TB31_tb.Text),
                                        Int16.Parse(TB22_tb.Text), Int16.Parse(TB13_tb.Text), Int16.Parse(TB30_tb.Text), Int16.Parse(TB21_tb.Text),
                                        Int16.Parse(TB12_tb.Text), Int16.Parse(TB03_tb.Text), Int16.Parse(TB20_tb.Text), Int16.Parse(TB11_tb.Text),
                                        Int16.Parse(TB02_tb.Text), Int16.Parse(TB10_tb.Text), Int16.Parse(TB01_tb.Text), Int16.Parse(TB00_tb.Text)  };

                //Binarizer Biner = new Binarizer();
                //Biner.Binarize(TB);

                Original_tb.Clear();
                int Original_tb_line = 0;


                uint[] Sig_coeff_flag = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
                char[] Sig_coeff_flag_writeout = "XXXXXXXXXXXXXXXXXXX".ToCharArray();
                int Sig_coeff_flag_index = 0;
                bool Sig_coeff_flag_First_Found = false;

                uint[] coeff_abs_level_greater1_flag = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
                char[] coeff_abs_level_greater1_flag_writeout = "XXXXXXXXXXX".ToCharArray();
                int coeff_abs_level_greater1_flag_index = 0;
                int coeff_abs_level_greater1_MaxIndex = 0;
                bool coeff_abs_level_greater1_flag_First_Found = false;

                uint[] coeff_abs_level_greater2_flag = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
                char[] coeff_abs_level_greater2_flag_writeout = "XXX".ToCharArray();
                bool coeff_abs_level_greater2_flag_First_Found = false;

                uint[] Sig_Plus_ALG1_Plus_ALG2 = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

                uint[] coeff_sign_flag = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
                char[] coeff_sign_flag_writeout = "XXXXXXXXXXXXXXXXXXX".ToCharArray();
                int coeff_sign_flag_index = 0;


                for (int i = 0; i < 16; i++)
                {
                    if (TBDiagonal[i] != 0)
                    {
                        if (Sig_coeff_flag_First_Found == false)
                        {
                            Sig_coeff_flag_index = i;
                            Sig_coeff_flag_First_Found = true;
                        }
                        Sig_coeff_flag[i] = 1;
                        Sig_Plus_ALG1_Plus_ALG2[i]++;
                        if (TBDiagonal[i] > 1 || -1 > TBDiagonal[i])
                        {
                            coeff_abs_level_greater1_flag[i] = 1;
                            coeff_abs_level_greater1_flag_First_Found = true;
                        }
                        if ((TBDiagonal[i] > 2 || -2 > TBDiagonal[i]))
                        {
                            coeff_abs_level_greater2_flag[i] = 1;
                        }
                        if (TBDiagonal[i] < 0)
                        {
                            coeff_sign_flag[i] = 1;
                        }
                    }
                }
                if (Sig_coeff_flag_First_Found == true)
                {
                    switch (Sig_coeff_flag_index)
                    {
                        // 0: 0 // 1: 10 // 2: 110 // 3: 111*
                        case 0:
                            AppendSyntaxElement("0,111".ToCharArray(), Original_tb, 5, ref Original_tb_line, Color.Red, Color.White);
                            AppendSyntaxElement("0,111".ToCharArray(), Original_tb, 5, ref Original_tb_line, Color.Red, Color.White);
                            break;
                        case 1:
                            AppendSyntaxElement("0,111".ToCharArray(), Original_tb, 5, ref Original_tb_line, Color.Red, Color.White);
                            AppendSyntaxElement("0,110".ToCharArray(), Original_tb, 5, ref Original_tb_line, Color.Red, Color.White);
                            break;
                        case 2:
                            AppendSyntaxElement("0,110".ToCharArray(), Original_tb, 5, ref Original_tb_line, Color.Red, Color.White);
                            AppendSyntaxElement("0,111".ToCharArray(), Original_tb, 5, ref Original_tb_line, Color.Red, Color.White);
                            break;
                        case 3:
                            AppendSyntaxElement("0,111".ToCharArray(), Original_tb, 5, ref Original_tb_line, Color.Red, Color.White);
                            AppendSyntaxElement("0,10".ToCharArray(), Original_tb, 4, ref Original_tb_line, Color.Red, Color.White);
                            break;
                        case 4:
                            AppendSyntaxElement("0,110".ToCharArray(), Original_tb, 5, ref Original_tb_line, Color.Red, Color.White);
                            AppendSyntaxElement("0,110".ToCharArray(), Original_tb, 5, ref Original_tb_line, Color.Red, Color.White);
                            break;
                        case 5:
                            AppendSyntaxElement("0,10".ToCharArray(), Original_tb, 4, ref Original_tb_line, Color.Red, Color.White);
                            AppendSyntaxElement("0,111".ToCharArray(), Original_tb, 5, ref Original_tb_line, Color.Red, Color.White);
                            break;
                        case 6:
                            AppendSyntaxElement("0,111".ToCharArray(), Original_tb, 5, ref Original_tb_line, Color.Red, Color.White);
                            AppendSyntaxElement("0,0".ToCharArray(), Original_tb, 3, ref Original_tb_line, Color.Red, Color.White);
                            break;
                        case 7:
                            AppendSyntaxElement("0,110".ToCharArray(), Original_tb, 5, ref Original_tb_line, Color.Red, Color.White);
                            AppendSyntaxElement("0,10".ToCharArray(), Original_tb, 4, ref Original_tb_line, Color.Red, Color.White);
                            break;
                        case 8:
                            AppendSyntaxElement("0,10".ToCharArray(), Original_tb, 4, ref Original_tb_line, Color.Red, Color.White);
                            AppendSyntaxElement("0,110".ToCharArray(), Original_tb, 5, ref Original_tb_line, Color.Red, Color.White);
                            break;
                        case 9:
                            AppendSyntaxElement("0,0".ToCharArray(), Original_tb, 3, ref Original_tb_line, Color.Red, Color.White);
                            AppendSyntaxElement("0,111".ToCharArray(), Original_tb, 5, ref Original_tb_line, Color.Red, Color.White);
                            break;
                        case 10:
                            AppendSyntaxElement("0,110".ToCharArray(), Original_tb, 5, ref Original_tb_line, Color.Red, Color.White);
                            AppendSyntaxElement("0,0".ToCharArray(), Original_tb, 3, ref Original_tb_line, Color.Red, Color.White);
                            break;
                        case 11:
                            AppendSyntaxElement("0,10".ToCharArray(), Original_tb, 4, ref Original_tb_line, Color.Red, Color.White);
                            AppendSyntaxElement("0,10".ToCharArray(), Original_tb, 4, ref Original_tb_line, Color.Red, Color.White);
                            break;
                        case 12:
                            AppendSyntaxElement("0,0".ToCharArray(), Original_tb, 3, ref Original_tb_line, Color.Red, Color.White);
                            AppendSyntaxElement("0,110".ToCharArray(), Original_tb, 4, ref Original_tb_line, Color.Red, Color.White);
                            break;
                        case 13:
                            AppendSyntaxElement("0,01".ToCharArray(), Original_tb, 4, ref Original_tb_line, Color.Red, Color.White);
                            AppendSyntaxElement("0,0".ToCharArray(), Original_tb, 3, ref Original_tb_line, Color.Red, Color.White);
                            break;
                        case 14:
                            AppendSyntaxElement("0,0".ToCharArray(), Original_tb, 3, ref Original_tb_line, Color.Red, Color.White);
                            AppendSyntaxElement("0,10".ToCharArray(), Original_tb, 4, ref Original_tb_line, Color.Red, Color.White);
                            break;
                        case 15:
                            AppendSyntaxElement("0,0".ToCharArray(), Original_tb, 3, ref Original_tb_line, Color.Red, Color.White);
                            AppendSyntaxElement("0,0".ToCharArray(), Original_tb, 3, ref Original_tb_line, Color.Red, Color.White);
                            break;
                        default:
                            break;
                    }
                }



                Sig_coeff_flag_First_Found = false;
                Sig_coeff_flag_index = 0;

                Sig_coeff_flag_writeout[Sig_coeff_flag_index++] = '0';
                Sig_coeff_flag_writeout[Sig_coeff_flag_index++] = ',';

                for (int i = 0; i < 16; i++)
                {
                    if (Sig_coeff_flag[i] == 1 && Sig_coeff_flag_First_Found == false)
                    {
                        Sig_coeff_flag_First_Found = true;
                    }
                    else if (Sig_coeff_flag_First_Found == true)
                    {
                        if (Sig_coeff_flag[i] != 0)
                        {
                            Sig_coeff_flag_writeout[Sig_coeff_flag_index++] = '1';
                        }
                        else
                        {
                            Sig_coeff_flag_writeout[Sig_coeff_flag_index++] = '0';
                        }
                    }
                }

                //MessageBox.Show("HERE Sig_coeff_flag_index:" + Sig_coeff_flag_index.ToString());

                if (Sig_coeff_flag_index != 0 || Sig_coeff_flag[0] >= 0)
                {
                    AppendSyntaxElement(Sig_coeff_flag_writeout, Original_tb, Sig_coeff_flag_index, ref Original_tb_line, Color.White, Color.Black);
                }


                ////char[] coeff_abs_level_greater1_flag = "XXXXXXXXXXXXXXXX".ToCharArray();

                ////char[] coeff_abs_level_greater2_flag = "X".ToCharArray();
                //bool coeff_abs_level_greater2_flag_found = false;

                coeff_abs_level_greater1_MaxIndex = 0;
                if (Sig_coeff_flag_First_Found == true)
                {
                    coeff_abs_level_greater1_flag_writeout[coeff_abs_level_greater1_flag_index++] = '0';
                    coeff_abs_level_greater1_flag_writeout[coeff_abs_level_greater1_flag_index++] = ',';
                    for (int i = 0; i < 16; i++)
                    {
                        if (Sig_coeff_flag[i] == 1 && coeff_abs_level_greater1_MaxIndex < 8)
                        {
                            if (coeff_abs_level_greater1_flag[i] == 1)
                            {
                                coeff_abs_level_greater1_flag_writeout[coeff_abs_level_greater1_flag_index++] = '1';
                                coeff_abs_level_greater1_MaxIndex++;
                                Sig_Plus_ALG1_Plus_ALG2[i]++;
                            }
                            else
                            {
                                coeff_abs_level_greater1_flag_writeout[coeff_abs_level_greater1_flag_index++] = '0';
                                coeff_abs_level_greater1_MaxIndex++;
                            }
                        }
                    }
                    AppendSyntaxElement(coeff_abs_level_greater1_flag_writeout, Original_tb, coeff_abs_level_greater1_flag_index, ref Original_tb_line, Color.Green, Color.White);


                    if (coeff_abs_level_greater1_flag_First_Found)
                    {
                        coeff_abs_level_greater2_flag_writeout[0] = '0';
                        coeff_abs_level_greater2_flag_writeout[1] = ',';
                        for (int i = 0; i < 16; i++)
                        {
                            if (coeff_abs_level_greater1_flag[i] == 1)
                            {
                                if (coeff_abs_level_greater2_flag[i] == 1)
                                {
                                    coeff_abs_level_greater2_flag_writeout[2] = '1';
                                    Sig_Plus_ALG1_Plus_ALG2[i]++;
                                }
                                else
                                {
                                    coeff_abs_level_greater2_flag_writeout[2] = '0';
                                }
                                break;
                            }
                        }
                        AppendSyntaxElement(coeff_abs_level_greater2_flag_writeout, Original_tb, 3, ref Original_tb_line, Color.Black, Color.White);

                    }

                    //if (coeff_abs_level_greater2_flag[0] == 1)
                    //{
                    //    coeff_abs_level_greater2_flag_writeout[2] = '1';
                    //}
                    //else
                    //{
                    //    coeff_abs_level_greater2_flag_writeout[2] = '0';
                    //}

                    int k = 0;
                    char[] writeout = new char[64];
                    char[] tempA;
                    int writeoutindex;
                    for (int i = 0; i < 16; i++)
                    {
                        if (coeff_abs_level_greater1_flag[i] == 1)
                        {   
                            writeoutindex = 0;
                            writeout = "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX".ToCharArray();
                            string temp = (Math.Abs(TBDiagonal[i]) - Sig_Plus_ALG1_Plus_ALG2[i]).ToString();
                            Int16 z = Int16.Parse(temp);
                            //AppendSyntaxElement(temp.ToCharArray(), Original_tb, temp.Length, ref Original_tb_line, Color.Orange);

                            if (z < Math.Pow(2, k))
                            {
                                writeout[writeoutindex++] = '1';
                                writeout[writeoutindex++] = ',';
                                writeout[writeoutindex++] = '0';
                                if (k > 0)
                                {
                                    tempA = Convert.ToString(z, 2).PadLeft(k, '0').ToCharArray();
                                    for (int g = 0; g < k; g++)
                                    {
                                        writeout[writeoutindex++] = tempA[g];
                                    }
                                }
                                else
                                {
                                }
                            }
                            else if (z < (2 * Math.Pow(2, k)))
                            {
                                writeout[writeoutindex++] = '1';
                                writeout[writeoutindex++] = ',';
                                writeout[writeoutindex++] = '1'; writeout[writeoutindex++] = '0';
                                if (k > 0)
                                {
                                    tempA = Convert.ToString(z, 2).PadLeft(k, '0').ToCharArray();
                                    for (int g = 0; g < k; g++)
                                    {
                                        writeout[writeoutindex++] = tempA[g];
                                    }
                                }
                                else
                                {
                                }
                            }
                            else if (z < (Math.Pow(2, k) * (Math.Pow(2, 0) + 2)))
                            {
                                writeout[writeoutindex++] = '1';
                                writeout[writeoutindex++] = ',';
                                writeout[writeoutindex++] = '1'; writeout[writeoutindex++] = '1'; writeout[writeoutindex++] = '0';
                                if (k > 0)
                                {
                                    tempA = Convert.ToString(z, 2).PadLeft(k, '0').ToCharArray();
                                    for (int g = 0; g < k; g++)
                                    {
                                        writeout[writeoutindex++] = tempA[g];
                                    }
                                }
                                else
                                {
                                }
                            }
                            else if (z < (Math.Pow(2, k) * (Math.Pow(2, 1) + 2)))
                            {
                                writeout[writeoutindex++] = '1';
                                writeout[writeoutindex++] = ',';
                                writeout[writeoutindex++] = '1'; writeout[writeoutindex++] = '1'; writeout[writeoutindex++] = '1'; writeout[writeoutindex++] = '0';
                                if (k > 0)
                                {
                                    tempA = Convert.ToString(z, 2).PadLeft(k, '0').ToCharArray();
                                    for (int g = 0; g < k; g++)
                                    {
                                        writeout[writeoutindex++] = tempA[g];
                                    }
                                }
                                else
                                {
                                }
                            }
                            else
                            {
                                writeout[writeoutindex++] = '1';
                                writeout[writeoutindex++] = ',';
                                for (int j = 5; j < 18; j++)
                                {
                                    int tempInt = (int)(Math.Pow(2, k) * (Math.Pow(2, j - 3) + 2));
                                    if (z < tempInt)
                                    {
                                        for (int h = 0; h < j - 1; h++)
                                        {
                                            writeout[writeoutindex++] = '1';
                                        }
                                        writeout[writeoutindex++] = '0';
                                        tempA = Convert.ToString(z - (int)(Math.Pow(2, k) * (Math.Pow(2, j - 4) + 2)), 2).PadLeft(j - 4 + k, '0').ToCharArray();
                                        for (int g = 0; g < j - 4 + k; g++)
                                        {
                                            writeout[writeoutindex++] = tempA[g];
                                        }
                                        j = 18;
                                    }
                                }
                            }

                            string temp2 = new string(writeout, 0, writeoutindex);
                            AppendSyntaxElement(temp2.ToCharArray(), Original_tb, writeoutindex, ref Original_tb_line, Color.Yellow, Color.Black);

                            if (k < 4 && z > (3 * (Math.Pow(2, k))))
                            {
                                k++;
                            }
                        }
                    }

                    // 6.5.2 SIGN BIT HIDING!?!?!?

                    coeff_sign_flag_writeout[coeff_sign_flag_index++] = '1';
                    coeff_sign_flag_writeout[coeff_sign_flag_index++] = ',';

                    for (int i = 0; i < 16; i++)
                    {
                        if (Sig_coeff_flag[i] == 1)
                        {
                            if (coeff_sign_flag[i] == 1)
                            {
                                coeff_sign_flag_writeout[coeff_sign_flag_index++] = '1';
                            }
                            else
                            {
                                coeff_sign_flag_writeout[coeff_sign_flag_index++] = '0';
                            }
                        }
                    }
                    string tempS = new string(coeff_sign_flag_writeout);
                    AppendSyntaxElement(tempS.ToCharArray(), Original_tb, coeff_sign_flag_index, ref Original_tb_line, Color.Blue, Color.White);


                }



            }
            catch (FormatException ex)
            {
                // TODO:
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }


        }

        private void AppendSyntaxElement(char[] tempA, RichTextBox tb,int Sindex, ref int lineNr, Color color, Color fontcolor)
        {
            string tempS = new string(tempA);
            tb.AppendText(" " + tempS.Substring(0, Sindex) + " \n");
            //tb.SelectAll();
            //tb.SelectionBackColor = tb.BackColor;
            var lines = tb.Lines;
            if (lineNr < 0 || lineNr >= lines.Length)
                return;
            var start = tb.GetFirstCharIndexFromLine(lineNr);  // Get the 1st char index of the appended text
            var length = lines[lineNr].Length;
            tb.Select(start, length);                 // Select from there to the end
            tb.SelectionBackColor = color;
            tb.SelectionColor = fontcolor;
            lineNr++;
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

#region Transform block editing

        private void Set_tb_within_UInt16_range(TextBox tb)
        {
            Int32 tempI = new Int32();
            try
            {
                if(tb.Text == "")
                {
                    tb.Text = "";
                }
                else if(Int32.TryParse(tb.Text, out tempI))
                {
                    tb.Text = Set_tb_with_min_max(tempI, tb, -Int16.MaxValue, Int16.MaxValue).ToString();
                }
                else
                {
                    tb.Text = "-";
                }
                Binarize_bt_Click(this, new EventArgs());
            }
            catch (FormatException ex)
            {
                tb.Text = "-";
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }

        private void TB00_tb_TextChanged(object sender, EventArgs e)
        {
            Set_tb_within_UInt16_range(TB00_tb);
        }

        private void TB10_tb_TextChanged(object sender, EventArgs e)
        {
            Set_tb_within_UInt16_range(TB10_tb);
        }

        private void TB20_tb_TextChanged(object sender, EventArgs e)
        {
            Set_tb_within_UInt16_range(TB20_tb);
        }

        private void TB30_tb_TextChanged(object sender, EventArgs e)
        {
            Set_tb_within_UInt16_range(TB30_tb);
        }

        private void TB01_tb_TextChanged(object sender, EventArgs e)
        {
            Set_tb_within_UInt16_range(TB01_tb);
        }

        private void TB11_tb_TextChanged(object sender, EventArgs e)
        {
            Set_tb_within_UInt16_range(TB11_tb);
        }

        private void TB21_tb_TextChanged(object sender, EventArgs e)
        {
            Set_tb_within_UInt16_range(TB21_tb);
        }

        private void TB31_tb_TextChanged(object sender, EventArgs e)
        {
            Set_tb_within_UInt16_range(TB31_tb);
        }

        private void TB02_tb_TextChanged(object sender, EventArgs e)
        {
            Set_tb_within_UInt16_range(TB02_tb);
        }

        private void TB12_tb_TextChanged(object sender, EventArgs e)
        {
            Set_tb_within_UInt16_range(TB12_tb);
        }

        private void TB22_tb_TextChanged(object sender, EventArgs e)
        {
            Set_tb_within_UInt16_range(TB22_tb);
        }

        private void TB32_tb_TextChanged(object sender, EventArgs e)
        {
            Set_tb_within_UInt16_range(TB32_tb);
        }

        private void TB03_tb_TextChanged(object sender, EventArgs e)
        {
            Set_tb_within_UInt16_range(TB03_tb);
        }

        private void TB13_tb_TextChanged(object sender, EventArgs e)
        {
            Set_tb_within_UInt16_range(TB13_tb);
        }

        private void TB23_tb_TextChanged(object sender, EventArgs e)
        {
            Set_tb_within_UInt16_range(TB23_tb);
        }

        private void TB33_tb_TextChanged(object sender, EventArgs e)
        {
            Set_tb_within_UInt16_range(TB33_tb);
        }

        #endregion

        private void Write_Testfile_bt_Click(object sender, EventArgs e)
        {
            try
            {
                StreamWriter testfile = initializeWriteFile("EncoderInput.txt");
                string tempS = Original_tb.Text;
                string[] tempSA = tempS.Replace(" ", "").Split('\n');
                for (int i = 0; i < tempSA.Length - 1; i++)
                {
                    testfile.WriteLine(tempSA[i]);
                }
                testfile.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }

        }

        private void FormatRTB(RichTextBox tb, int length, string Input)
        {
            tb.Clear();
            char[] tempA = Input.ToCharArray();
            int index = 0;
            for(int i = 0; i < Input.Length; i++)
            {
                if (index % int.Parse(Original_DataLength_tb.Text) == 0 && index != 0)
                {
                    tb.AppendText("\n");
                    index = 0;
                }
                tb.AppendText(tempA[i].ToString());
                index++;
            }
        }

        private void Load_from_TB_Click(object sender, EventArgs e)
        {
            try
            {
                StreamReader fromTB = initializeReadFile("EncoderOutput.txt");
                if (fromTB != null)
                {

                    DecoderInput_tb.Clear();

                    DecoderInput_tb.AppendText(ReplaceNewlines(fromTB.ReadToEnd(), ""));

                    fromTB.Close();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }

        private void Compare_HW_and_SW_encoding_bt_Click(object sender, EventArgs e)
        {
            try
            {
                char[] longest, shortest;
                HW_vs_SW_errorpos_tb.Text = " ";
                if (Encoded_Here_tb.Text.Length > DecoderInput_tb.Text.Length) {
                    longest = Encoded_Here_tb.Text.ToCharArray();
                    shortest = DecoderInput_tb.Text.ToCharArray();
                }
                else
                {
                    shortest = Encoded_Here_tb.Text.ToCharArray();
                    longest = DecoderInput_tb.Text.ToCharArray();
                }
                HW_vs_SW_pb.Maximum = longest.Length;
                HW_vs_SW_pb.Value = 0;
                foreach (char c in shortest)
                {
                    if (c == longest[HW_vs_SW_pb.Value])
                    {
                        HW_vs_SW_percentage_tb.Text = (float.Parse(HW_vs_SW_pb.Value.ToString()) * 100 / float.Parse(longest.Length.ToString())).ToString() + "%";
                    }
                    else
                    {
                        HW_vs_SW_errorpos_tb.Text = "Errorindex: " + HW_vs_SW_pb.Value.ToString();
                        return;
                    }
                    HW_vs_SW_pb.Value++;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }

        private void write_bin_testfile_bt_Click(object sender, EventArgs e)
        {
            StreamWriter Output = initializeWriteFile("BinarizerTestfile.txt");

            Int16[,] TB = { { Int16.Parse(TB00_tb.Text), Int16.Parse(TB01_tb.Text), Int16.Parse(TB02_tb.Text), Int16.Parse(TB03_tb.Text) },
                            { Int16.Parse(TB10_tb.Text), Int16.Parse(TB11_tb.Text), Int16.Parse(TB12_tb.Text), Int16.Parse(TB13_tb.Text) },
                            { Int16.Parse(TB20_tb.Text), Int16.Parse(TB21_tb.Text), Int16.Parse(TB22_tb.Text), Int16.Parse(TB23_tb.Text) },
                            { Int16.Parse(TB30_tb.Text), Int16.Parse(TB31_tb.Text), Int16.Parse(TB32_tb.Text), Int16.Parse(TB33_tb.Text) } };
            for(int i = 0; i < 4; i++)
            {
                for(int j = 0; j < 4; j++)
                {
                    Output.WriteLine(Convert.ToString(TB[i,j], 2).PadLeft(16, '0'));
                }
            }
            Output.Close();
        }

        private void Test_bt_Click(object sender, EventArgs e)
        {   
            int[] k0 =  {   0, 
                            1,
                            2,
                            3,
                            4,
                            6,
                            10,
                            18,
                            34,
                            66,
                            130,
                            258,
                            514,
                            1026,
                            2050,
                            4098,
                            8194,
                            16386   };

            int abs_level = int.Parse(Test_tb.Text);
            int[] result = new int[18];
            int xorresult = new int();


            for (int i = 0; i < 18; i++)
            {
                result[i] = abs_level - k0[i];
            }

            for (int i = 0; i < 17; i++)
            {
                if ((result[i] >= 0) ^ (result[i + 1] >= 0))
                {
                    xorresult = 1 << i;
                }
            }
            DecoderOutput_tb.Clear();
            DecoderOutput_tb.AppendText(Convert.ToString(xorresult, 2).PadLeft(17, '0') + "\n");
            DecoderOutput_tb.AppendText(Math.Log(xorresult, 2).ToString() + "\n");
            DecoderOutput_tb.AppendText((abs_level - k0[(int)Math.Log(xorresult, 2)]).ToString() + "\n");


            for (int i = 0; i < 18; i++)
            {
                if (abs_level - k0[i] >= 0)
                {
                    result[0] = i;
                    DecoderOutput_tb.AppendText(result[0].ToString() + "\n");
                    DecoderOutput_tb.AppendText((abs_level - k0[result[0]]).ToString());
                    return;
                }
            }

            //DecoderOutput_tb.Clear();
        }

        string ReplaceNewlines(string blockOfText, string replaceWith)
        {
            return blockOfText.Replace("\r\n", replaceWith).Replace("\n", replaceWith).Replace("\r", replaceWith).Replace(" ", replaceWith);
        }

        string FormatDecoderInput(string blockOfText)
        {
            return blockOfText.Replace("\r\n", "\n").Replace("\n\n", "\n").Replace("\r\r", "\n").Replace(" ", "");
        }

        private uint uSet_tb_with_min_max(uint set, TextBox tb, uint min, uint max)
        {
            try
            {
                if (tb.Text != "")
                {
                    uint temp = new uint();
                    uint.TryParse(tb.Text, out temp);
                    if (temp <= min)
                    {
                        tb.Text = min.ToString();
                        set = min;
                    }
                    else if (temp > max)
                    {
                        tb.Text = max.ToString();
                        set = max;
                    }
                    else
                    {
                        set = temp;
                    }
                    tb.Select(tb.TextLength, 0);
                    return set;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
            return set;
        }

        private int Set_tb_with_min_max(int set, TextBox tb, int min, int max)
        {
            try
            {
                if (tb.Text != "")
                {
                    int temp = new int();
                    int.TryParse(tb.Text, out temp);
                    if (temp <= min)
                    {
                        tb.Text = min.ToString();
                        set = min;
                    }
                    else if (temp > max)
                    {
                        tb.Text = max.ToString();
                        set = max;
                    }
                    else
                    {
                        set = temp;
                    }
                    tb.Select(tb.TextLength, 0);
                    return set;
                }
            }
            catch (FormatException ex)
            {
                tb.Text = "-";
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
            return set;
        }

        private void Offset_change(object sender, EventArgs e)
        {
            initType_tb_TextChanged(sender, e);
            SliceQPY_tb_TextChanged(sender, e);
            ContextIndex_tb_TextChanged(sender, e);
            ReloadTables();
            DisplayCtxStatus();
        }

        private void initType_tb_TextChanged(object sender, EventArgs e)
        {
            initType = uSet_tb_with_min_max(initType, initType_tb, 0, 2);
            offset = ctxIdxTable_depth * initType + ctxIdxTable_depth * 3 * sliceQPY + ContextIndex;
            DisplayCtxStatus();
        }

        private void SliceQPY_tb_TextChanged(object sender, EventArgs e)
        {
            sliceQPY = uSet_tb_with_min_max(sliceQPY, SliceQPY_tb, 0, 51);
            offset = ctxIdxTable_depth * initType + ctxIdxTable_depth * 3 * sliceQPY + ContextIndex;
            DisplayCtxStatus();
        }

        private void ContextIndex_tb_TextChanged(object sender, EventArgs e)
        {
            ContextIndex = uSet_tb_with_min_max(ContextIndex, ContextIndex_tb, 0, ctxIdxTable_depth - 1);
            offset = ctxIdxTable_depth * initType + ctxIdxTable_depth * 3 * sliceQPY + ContextIndex;
            DisplayCtxStatus();
        }



    }
}
