library ieee;
library std;

use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.std_logic_unsigned.all;
use ieee.math_real.all;

package RegularParameters is

    constant rangeTabLPS_precision : integer := 8;

    constant InputWidth : integer := 16; 
    constant InputWidthLength : integer := integer(floor(log2(real(InputWidth))+real(1)));
    constant OutputWidth : integer := InputWidth; 
    constant OutputWidthLength : integer := integer(floor(log2(real(OutputWidth))+real(1))); -- Number of bits required to represent OutputWidth.

end RegularParameters;